<?php
//#############################################################################\\
//# PANDA Captcha                                                              #\\
//# Author: Christopher Schiffner - chris@schiffner.com                       #\\
//# Copyright: Christopher Schiffner - 2019                                   #\\
//#############################################################################\\

@session_name("panda_captcha_for_wp_panda_mailer");
@session_start();

$captchaCodeLength=7;

//dimensions 
$width = 210;
$height = 40;

$fontsize = mt_rand(18, 23);

$fontangle=mt_rand(-3, 3);

// colors
$bgR = mt_rand(128, 255);
$bgG = mt_rand(128, 255);
$bgB = mt_rand(128, 255);
        
$txtR=$bgR - 128;
$txtG=$bgG - 128;
$txtB=$bgB - 128;

$gridR=$bgR - 110;
$gridG=$bgG - 110;
$gridB=$bgB - 110;

$gridXincrement=5;
$gridYincrement=5;

$angleX=10;
$angleY=8;

/* Random Character String Code 
   ommiting common problematic characters
*/
$characterPool = 'abcdefghjkmnprsruvABCDEFGHJKMNPRSTUV123456789';
$captchaString = '';
for($x = 0; $x < $captchaCodeLength; $x++){
   $randomPosition = mt_rand(0, strlen($characterPool)-1);
   $captchaString .= substr($characterPool, $randomPosition, 1)." ";
}

//store captcha session variable
$_SESSION['captcha']=str_replace(" ", "", $captchaString);

// create new image with specified dimensions
$image = imagecreate($width, $height);

// generate color
$bgColor = imagecolorallocate($image, $bgR, $bgG, $bgB);
$txtColor = imagecolorallocate($image, $txtR, $txtG, $txtB);
$gridColor = imagecolorallocate($image, $gridR, $gridG, $gridB);

// apply the background
imagefill($image, 0, 0, $bgColor);
 
// Generate a grid to help distort image
for($gridX = 0; $gridX <= $width; $gridX+=$gridXincrement){
    $gridXRAND=mt_rand($gridX, $gridX+3);
    imageline($image, $gridXRAND, 0, $gridXRAND + mt_rand(0, $angleX), $height, $gridColor);
}
for($gridY = 0; $gridY <= $height; $gridY+=$gridYincrement){
    $gridYRAND = mt_rand($gridY, $gridY + 6);
    imageline($image, 0, $gridYRAND, $width, $gridYRAND + mt_rand(0, $angleY), $gridColor);
}

// write the random string to the image
$x=mt_rand(10, 20);
$y=mt_rand(3, 8);

imagettftext($image, $fontsize, $fontangle, 10, ($height / 2 + ($fontsize / 2)), $txtColor, "arialbd.ttf", $captchaString);

// put a border on the box
imagerectangle($image, 0, 0, $width - 1, $height - 1, $txtColor);

// set headers to prevent image cache, and identify as gif, output image, clean obj
header('Expires: Tue, 08 Oct 1991 00:00:00 GMT');
header('Cache-Control: no-cache, must-revalidate');
header("Content-Type: image/gif");
imagegif($image);
imagedestroy($image); 
?>
