<?php
//#############################################################################\\
//# PANDA Mailer                                                              #\\
//# Author: Christopher Schiffner - chris@schiffner.com                       #\\
//# Copyright: Christopher Schiffner - 2019                                   #\\  
//#############################################################################\\

if(file_exists("../../../wp-blog-header.php")){
	require_once("../../../wp-blog-header.php");
}

$data = get_option('wp_panda_mailer');

extract(shortcode_atts(array(
		            'ary_recipients' => $data['recipients'],
		            'ary_subjects' => $data['subjects']
					  ), $atts)
		);

@session_name("panda_captcha_for_wp_panda_mailer");
@session_start();

if(	isset($_SESSION['captcha']) ){
	$challenge=strtolower($_SESSION['captcha']);
}else{
	$challenge="";
}

if(	isset($_POST['response']) ){
	$response=strtolower(trim($_POST['response']));
}else{
	$response="";
}

if(	isset($_POST['from']) ){
	$from=filter_var($_POST['from'], FILTER_SANITIZE_EMAIL);
}else{
	$from="";
}

$website="";
if(	isset($_POST['website']) ){
	$website=$_POST['website'];
}

$recipient=-1;
if(	isset($_POST['recipient']) ){
	$recipient=$_POST['recipient'];
}

$subject=-1;
if(	isset($_POST['subject']) ){
	$subject=$_POST['subject'];
}

$returnto=$_POST['returnto'];

$message=stripslashes($_POST['message']);

//perform our error checking and redirect the user for feedback & correction
if($website!=""){
	die();
}else if($challenge=="" || $response=="" || trim($from)=="" || $from=="" || $from=="your-email@somedomain.com" || $recipient < 0 || $subject < 0 || trim($message)==""){
    $message=urlencode($message);
    $subject=urlencode($subject);
    $from=urlencode($from);
    header("Location: ".$returnto."?wppmerror=fieldBlank&from=$from&message=$message&recipient=$recipient&subject=$subject#wp_panda_mailer");
}else if($challenge!=$response){
    $message=urlencode($message);
    $subject=urlencode($subject);
    $from=urlencode($from);
    header("Location: ".$returnto."?wppmerror=codeMismatch&from=$from&message=$message&recipient=$recipient&subject=$subject#wp_panda_mailer");
}else if( !isset($ary_recipients[$recipient]) ){
	print_r($ary_recipients);
	//die("ERROR: No recipient (".$recipient.")");
}else if( !isset($ary_subjects[$subject]) ){
	die("ERROR: No subject");
}else if ( strpos($from, '@') == false || strpos($from, '.') == false || !filter_var($from, FILTER_VALIDATE_EMAIL) ) {
	$message=urlencode($message);
	$subject=urlencode($subject);
	$from=urlencode($from);
	header("Location: ".$returnto."?wppmerror=invalidEmail&from=$from&message=$message&recipient=$recipient&subject=$subject#wp_panda_mailer");
}else if ( strtolower( substr( $from, (strpos($from, "@") + 1))) == strtolower(gethostname()) ) {
	$message=urlencode($message);
	$subject=urlencode($subject);
	$from=urlencode($from);
	header("Location: ".$returnto."?wppmerror=invalidEmailHost&from=$from&message=$message&recipient=$recipient&subject=$subject#wp_panda_mailer");
}else{
	$recipient = $ary_recipients[$recipient][1];
	$subject=$ary_subjects[$subject];

    // To send the HTML mail we need to set the Content-type header.
    $eol="\r\n";
    $headers  = "From: ".$from.$eol;
    $headers .= "Reply-To: ".$from.$eol;
    $headers .= "Return-Path: ".$from.$eol;
    $headers .= "Message-ID: <".$now.$from.">".$eol;
    $headers .= "X-Mailer: PHP/".phpversion().$eol;
    $mime_boundary=md5(time());
    $headers .= "MIME-Version: 1.0".$eol;
    $headers .= "Content-type: text/plain; charset=UTF-8".$eol;

    //send the email!
    mail($recipient,$subject,$message,$headers);

    //EDIT THIS LINK TO GO TO WHATEVER PAGE YOU WISH
    header("Location: $returnto?wppmerror=sent#wp_panda_mailer");
}
?>
